-- by mor2000

PushObjectRaycastEvent = {}
PushObjectRaycastEvent_mt = Class(PushObjectRaycastEvent, Event)

InitEventClass(PushObjectRaycastEvent, "PushObjectRaycastEvent")

function PushObjectRaycastEvent:emptyNew()
	local self = Event:new(PushObjectRaycastEvent_mt)
	return self
end

function PushObjectRaycastEvent:new(camx, camy, camz, dirx, diry, dirz, rotY, dtSum)
	local self = PushObjectRaycastEvent:emptyNew()
	self.camx = round(camx*100)
	self.camy = round(camy*100)
	self.camz = round(camz*100)
	self.dirx = round(dirx*1000)
	self.diry = round(diry*1000)
	self.dirz = round(dirz*1000)
	self.rotY = round(rotY*1000)
	self.dtSum = round(dtSum)
	return self
end

function PushObjectRaycastEvent:writeStream(streamId, connection)
	if connection.getIsServer(connection) then
		-- send data to server
		streamWriteAuto(streamId, self.camx, self.camy, self.camz, self.dirx, self.diry, self.dirz, self.rotY, self.dtSum)
	end
end

function PushObjectRaycastEvent:readStream(streamId, connection)
	if not connection.getIsServer(connection) then
		-- receive data from client
		local camx, camy, camz, dirx, diry, dirz, rotY, dtSum = streamReadAuto(streamId)
		PushObjectListener:findAndPushObject(camx/100, camy/100, camz/100, dirx/1000, diry/1000, dirz/1000, rotY/1000, dtSum)
	end
end

function PushObjectRaycastEvent.sendEvent(camx, camy, camz, dirx, diry, dirz, rotY, dtSum, alreadySent)
	if not alreadySent then
		if g_server == nil then
			g_client:getServerConnection():sendEvent(PushObjectRaycastEvent:new(camx, camy, camz, dirx, diry, dirz, rotY, dtSum))
		end
	end
end 
